require 's3search/result_page'

module S3Search
  module API
    module Documents

      def create data, options={}
        raise 'use create_many for multiple documents' if data.is_a?(Array)
        _post('/v1/documents.json', {data: data, options: options})
      end

      def create_many data, options={}
        response = _post('/v1/documents.json', {data: [data].flatten}, options: options)
        response.results
      end

      def delete id
        _delete "/v1/documents/#{id}.json"
      end

      def get id
        _get "/v1/documents/#{id}.json"
      end

      def update id, attributes
        _put("/v1/documents/#{id}.json", {document: attributes})
      end

      def get_all options={}
        options[:page] ||= 1
        options[:per_page] ||= 25
        response = _get("/v1/documents.json", options)
        S3Search::ResultPage.new(response, self)
      end
    end
  end
end
